VERSION 5.00
Object = "{9D392231-AE8E-11D4-8FD3-00D0B7730277}#1.0#0"; "ywcvwr.dll"
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "mscomctl.ocx"
Begin VB.Form FrmCamView 
   Caption         =   "Mattbys Simple Anonymous Viewer"
   ClientHeight    =   4185
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4320
   Icon            =   "Form1.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   145.793
   ScaleMode       =   0  'User
   ScaleWidth      =   261.626
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton CmdConnect 
      Caption         =   "&Connect"
      Default         =   -1  'True
      Height          =   310
      Left            =   2760
      TabIndex        =   3
      Top             =   120
      Width           =   855
   End
   Begin VB.TextBox txtUser 
      Height          =   285
      Left            =   1080
      TabIndex        =   2
      Top             =   120
      Width           =   1575
   End
   Begin MSComctlLib.StatusBar StatusBar1 
      Align           =   2  'Align Bottom
      Height          =   255
      Left            =   0
      TabIndex        =   1
      Top             =   3930
      Width           =   4320
      _ExtentX        =   7620
      _ExtentY        =   450
      _Version        =   393216
      BeginProperty Panels {8E3867A5-8586-11D1-B16A-00C0F0283628} 
         NumPanels       =   2
         BeginProperty Panel1 {8E3867AB-8586-11D1-B16A-00C0F0283628} 
            AutoSize        =   1
            Object.Width           =   4551
         EndProperty
         BeginProperty Panel2 {8E3867AB-8586-11D1-B16A-00C0F0283628} 
            Style           =   5
            AutoSize        =   2
            TextSave        =   "16:54"
         EndProperty
      EndProperty
   End
   Begin YWCVWRLibCtl.WcViewer Wc1 
      Height          =   2775
      Left            =   120
      OleObjectBlob   =   "Form1.frx":030A
      TabIndex        =   0
      Top             =   720
      Width           =   3615
   End
   Begin VB.Label lblUser 
      Caption         =   "Enter Cam ID:"
      Height          =   255
      Left            =   0
      TabIndex        =   4
      Top             =   120
      Width           =   1095
   End
End
Attribute VB_Name = "FrmCamView"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
' Mattby's simple cam viewer - This program has been writen to demonstrate a simple basic way of
' connecting to and viewing a Yahoo cam.
' This makes use of Yahoo's ywcvwr.dll viewer component.

Private Sub CmdConnect_Click()
    ' pass the name typed in the txtuser text box to the connectcam method
    If txtUser.Text <> "" Then ConnectCam txtUser.Text
End Sub

Public Sub ConnectCam(sUser As String, Optional sLoggedUser As String, Optional sToken As String)
    ' This is where we tell the viewer to start receiving. First we put in some connection properties
    ' Note that the Yahoo WCViewer control is not documented anywhere so a lot of the values are by trial and error
    ' You may experiment with the values below and properties/methods not used here i.e. there is a zoom property you may wish to experiment with.
    '
    ' The most important field value to set is the targetname which = the Yahoo ID of the cam you wish to view
    With Wc1
        .Age = 25
        .AppName = 1234
        .CountryCode = "us"
        .TargetName = sUser
        ' If we wish to connect as a 'named' user we would need to set the username and token fields
        ' To get these you would need to use the YMSG protocol to log in as the anmed user and request the token
        If sToken <> "" And sLoggedUser <> "" Then
            .UserName = sLoggedUser
            .Token = sToken
        Else
            .UserName = ""
            .Token = ""
        End If
        ' finally invoke the receive method
        .Receive
    End With

End Sub

Private Sub Form_Load()

End Sub

Private Sub Wc1_OnConnectionStatusChanged(ByVal iStatusCode As Long)
' We can use this event to tell us the various cam status states
' and act on them accordingly as/if required

Select Case iStatusCode
Case 2
    ' 2 = connecting to cam
    StatusBar1.Panels(1).Text = "Connecting..."
Case 4
    ' 4 = established link to online cam , now requesting permission to view
    StatusBar1.Panels(1).Text = "Requesting Access..."
Case 6
    ' 5 = viewing the cam
    StatusBar1.Panels(1).Text = "Viewing " & Wc1.TargetName
Case 8
    ' 8 = user has pused cam
    StatusBar1.Panels(1).Text = "User Paused.."
Case 1
    ' 1 = cam offline
    StatusBar1.Panels(1).Text = "Cam Offline"
Case 3
    ' 3 = cam was aborted
End Select

DoEvents

End Sub

Private Sub Wc1_OnFinishedReceiving(ByVal iErrCode As Long)
    ' This event tells us the various cam states returned
    Select Case iErrCode
    Case 1
        ' cam was stopped
        StatusBar1.Panels(1).Text = "Cam stopped"
    Case 2
        ' connecting
    Case 6
        ' cam now offline
        StatusBar1.Panels(1).Text = "Cam Offline"
    Case 15
        ' permission was refused
        StatusBar1.Panels(1).Text = "Permission Denied"
    Case 13
        ' cam is full
        StatusBar1.Panels(1).Text = "Cam Is Full"
    End Select

End Sub


Private Sub Wc1_OnResize(ByVal iNewWidth As Long, ByVal iNewHeight As Long)
    ' Very simple resizing method. This is just based on the assumption Yahoo cams only broadcast
    ' ever in a small or large image.
    
    On Error Resume Next
    If Not Me.WindowState = vbMinimized Then
        Wc1.Height = iNewHeight
        Wc1.Width = iNewWidth
        If Wc1.Width > 250 Then
            ' large being broadcast
            Wc1.Visible = False
            Me.Width = 5250
            Me.Height = 5250
            Wc1.Visible = True
        Else
            ' small being broadcast
            Wc1.Visible = False
            Me.Width = 3900
            Me.Height = 3600
            Wc1.Visible = True
        End If
        Me.Refresh
        DoEvents
    End If

End Sub


